]> git.treefish.org Git - backmeupscotty.git/blobdiff - backmeupscotty
Made ssh calls 255 aware.
[backmeupscotty.git] / backmeupscotty
index c1fa9da8387aea23f276e1092c8abf31c9fd191c..df18802d226b8b3e9079458edf2870a1ecac5912 100644 (file)
@@ -18,21 +18,32 @@ function scottyerror {
     echo $(upperme): $@ >&2 
 }
 
+function ssh255 {
+    ssh $@
+    sshret=$?
+
+    if [ $sshret -eq 255 ]; then
+       scottyerror "SSH connection failed!"
+       exit 1
+    else
+       return $sshret
+    fi
+}
+
 function grepbackups {
-    ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+    ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
 }
 
 function isIncomplete {
-    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+    if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
        return 0
     else
        return 1
     fi
 }
 
-function isIncompleteOrNthDay {
-    if isIncomplete || \
-       [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
+function isNthDay {
+    if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
     then
        return 0
     else
@@ -40,6 +51,20 @@ function isIncompleteOrNthDay {
     fi 
 }
 
+function latestTooOld {
+    for oldbackup in $(grepbackups); do
+       tstamp=$(echo $oldbackup | cut -d'-' -f1)
+       
+       if [ $(( $(date +%s) - $tstamp )) -lt \
+           $(( $BACKUP_RUNEVERYNTHDAY*24*60*60 )) ]
+       then
+           return 1
+       fi
+    done
+
+    return 0
+}
+
 function scottysync {
     timestamp=$(date +%s)
 
@@ -65,9 +90,9 @@ function scottysync {
        rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
-    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+    if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
        scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
-       ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
+       ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
     if isIncomplete; then
@@ -83,7 +108,7 @@ function scottysync {
     
     if [ $? -eq 0 ]; then
        scottyinfo Timestamping completed backup and linking to current backup
-       ssh $REMOTE_HOST \
+       ssh255 $REMOTE_HOST \
            "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
     fi
 
@@ -93,7 +118,7 @@ function scottysync {
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
            scottyinfo Removing old backup $oldestbackup
-           ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+           ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
        else
            break
        fi
@@ -110,67 +135,87 @@ function prepare {
     scottyinfo "Preparing for sync"
 }
 
-function cleanup_abrt {
-    scottyinfo "No cleanup_abrt function was defined."
-}
-
-function _cleanup_abrt {
+function cleanup_abort {
     scottyerror "Caught exit signal! Cleaning up..."
 
-    cleanup_abrt
+    cleanup ABORT
 
     if [ $(jobs -p) ]; then
        scottyerror TERMinating remaining child processes...
        kill $(jobs -p)
     fi
+
     deleteLock
+
     exit
 }
 
-function prepare {
-    scottyinfo "No prepare function was defined."
+function cleanup {
+    scottyinfo "No cleanup function was defined."
 }
 
-function _prepare {
-    prepare
+function prepare {
+    scottyinfo "No prepare function was defined."
 }
 
 function cleanup_normal {
-    scottyinfo "No cleanup_normal function was defined."
+    cleanup
+    deleteLock
 }
 
-function _cleanup_normal {
-    cleanup_normal
-    deleteLock
+function printhelp {
+    cat <<EOF
+Usage: $(basename $0) [OPTION]...
+
+Recognized options:
+  -q   Only output errors
+  -n   Run only on nth day
+  -h   Print out this help
+EOF
 }
 
 function backmeupscotty {
-    if ! isIncompleteOrNthDay; then
-       scottyinfo "This is not the nth day and no incomplete backup exists."
+    while getopts "qn:h" opt; do
+       case $opt in
+           q)
+               exec > /dev/null
+               ;;
+           n)
+               BACKUP_RUNEVERYNTHDAY=$OPTARG
+               ;;
+           h)
+               printhelp
+                exit 0
+                ;;
+       esac
+    done
+    
+    ssh255 $REMOTE_HOST exit
+    
+    if isNthDay; then
+       scottyinfo "This is the nth day."
+    elif latestTooOld; then
+       scottyinfo "The latest backup is too old."
+    else
+       scottyinfo "No backup has to be done. Exiting."
        exit 0
     fi
 
-    trap _cleanup_abrt EXIT
+    scottyinfo "Performing backup."
+
+    trap cleanup_abort EXIT
 
-    _prepare
+    prepare
     scottysync
-    _cleanup_normal
 
-    trap - EXIT
+    trap cleanup_normal EXIT
+
+    exit 0
 }
 
 if ! mkdir /tmp/$(basename $0).lock; then
     scottyerror "Another instance of $(basename $0) is still running!"
     exit 1
+else
+    trap deleteLock EXIT
 fi
-
-while getopts "qn:" opt; do
-    case $opt in
-       q)
-           exec > /dev/null
-           ;;
-       n)
-           BACKUP_RUNEVERYNTHDAY=$OPTARG
-           ;;
-    esac
-done